<template>
  <div>
    <v-navigation-drawer v-model="drawer" clipped app>
      <v-list dense class="pt-5 ma-0">
        <v-list-item @click="goToHome">
          <v-list-item-action class="mr-5">
            <v-icon color="primary">mdi-home</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>Home</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>
      <v-list dense class="pa-0 ma-0">
        <v-list-item v-if="hasDrive" @click="goToDrive">
          <!-- <v-list-item @click="goToDrive"> -->
          <v-list-item-action class="mr-5">
            <v-icon color="primary">mdi-folder-account</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>Drive</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>
      <span v-if="adminEntity.length > 0">
        <v-subheader>Administrar</v-subheader>
        <v-list dense class="pt-0">
          <v-list-item
            v-for="entity in adminEntity"
            :key="entity.id"
            exact
            router
            @click="handleEntityRoute(entity.id, entity.name)"
          >
            <v-list-item-action class="mr-5">
              <v-icon color="primary">mdi-cog</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title
                v-text="entity.firstName ? `${entity.firstName}` : `${entity.name}`"
              />
              <span v-if="entity.firstName" style="font-size:0.8rem; color: grey">{{
                entity.name
              }}</span>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </span>
      <span v-if="this.entities.length > 0">
        <v-subheader>Entidades</v-subheader>
        <v-list dense class="pt-0">
          <v-list-item
            v-for="entity in entities"
            :key="entity.id"
            exact
            router
            @click="handleEntityRoute(entity.id, entity.name)"
          >
            <v-list-item-action class="mr-5">
              <v-icon color="primary">mdi-notebook</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title
                v-text="entity.firstName ? `${entity.firstName}` : `${entity.name}`"
              />
              <span v-if="entity.firstName" style="font-size:0.8rem; color: grey">{{
                entity.name
              }}</span>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </span>
    </v-navigation-drawer>
    <v-app-bar clipped-left app fixed color="primary">
      <v-app-bar-nav-icon color="white" @click.stop="drawer = !drawer" />
      <v-btn text @click="handleHome">
        <v-toolbar-title class="headline text-uppercase test--text">
          <span>Udesc</span>
        </v-toolbar-title>
        <v-divider class="mx-1 my-1" vertical color="white" />
        <v-toolbar-title class="headline text-uppercase white--text">
          <span class="font-weight-light">Polvo</span>
        </v-toolbar-title>
      </v-btn>
      <v-spacer />
      <Configuration />
      <!-- <v-btn text color="white" @click="handleLogout">
        <span class="mr-2">{{ $vuetify.lang.t('$vuetify.logout.text') }}</span>
        <v-icon>mdi-logout</v-icon>
      </v-btn> -->
    </v-app-bar>
    <ChangePassword />
  </div>
</template>

<script>
import Configuration from '../components/user/Configuration'
import User from '../services/user'
import ChangePassword from '../components/user/ChangePassword'
import { mapMutations, mapState } from 'vuex'

export default {
  name: 'TheToolbar',
  components: {
    ChangePassword,
    Configuration,
  },
  data() {
    return {
      drawer: true,
      hasDrive: false,
      adminEntity: [],
      entities: [],
    }
  },
  computed: {
    ...mapState('user', ['toolbarEntities', 'modulesMaxManagements', 'refreshNameEntities']),
  },
  async created() {
    const logged = await sessionStorage.getItem('logged')
    if (!logged && this.$route.name !== 'Login') {
      this.$router.push('/')
      return
    }
    this.checkHasDrive()
    this.checkEntities()
  },

  watch: {
    async refreshNameEntities() {
      if (this.refreshNameEntities == true) {
        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id
        const entityName = routedEntity.name
        let foundEntity = false

        this.adminEntity.forEach((item) => {
          if (item.id == entityId) {
            Object.assign(item, { name: entityName })
            foundEntity = true
            this.$store.commit('user/UPDATE_REFRESH_NAME_ENTITIES', false)
            return
          }
        })

        if (foundEntity) return

        this.entities.forEach((item) => {
          if (item.id == entityId) {
            Object.assign(item, { name: entityName })
            this.$store.commit('user/UPDATE_REFRESH_NAME_ENTITIES', false)
            return
          }
        })
      }
    },
  },

  methods: {
    ...mapMutations('user', [
      'UPDATE_LOGGED',
      'UPDATE_USER_CHANGE_PASSWORD',
      'UPDATE_ROUTED_ENTITY',
      'UPDATE_ENTITY_CHILDREN',
      'UPDATE_ROUTED_ENTITY_ROLES',
      'UPDATE_MAPPED_ACTIONS',
      'UPDATE_SET_ACTIONS',
    ]),
    async handleHome() {
      await this.$router.push('/home').catch((err) => {})
    },
    async handleLogout() {
      try {
        let ret = await User.logout()
        if (ret.data.success) {
          this.UPDATE_LOGGED(false)
          // await this.$clearStorage()
          await this.$removeItem('accessKey')
          await this.$removeItem('accessKeyEHQ')
          await this.$removeItem('authenticationKeyEHQ')
          await this.$removeItem('entityChildren')
          await this.$removeItem('logged')
          await this.$removeItem('navEntityHistory')
          await this.$removeItem('rootEntities')
          await this.$removeItem('routedEntity')
          await this.$removeItem('toolbarEntities')
          await this.$removeItem('userEHQ')
          await this.$removeItem('userInfo')

          this.$router.push('/').catch((err) => {})
        }
      } catch (e) {
        console.log(e)
      }
    },
    async handleEntityRoute(entityId, entityTitle) {
      // console.log('clicou p/ mudar entidade')
      try {
        let ret = await User.readEntityChild(entityId)
        await this.$setItem('entityChildren', ret.data)
        this.UPDATE_ENTITY_CHILDREN(ret.data)
      } catch (e) {
        console.log('e', e)
      }
      await this.UPDATE_ROUTED_ENTITY(entityId)
      const routedEntity = await this.$getItem('routedEntity')
      if (routedEntity) {
        const userEntityActions = routedEntity.privileges.actions
        let setMethods = new Set()
        let map = new Map(
          userEntityActions.map((action) => {
            action.methods.forEach((method) => {
              setMethods.add(method)
            })
            return [action.name, action]
          })
        )
        this.UPDATE_MAPPED_ACTIONS(map)
        this.UPDATE_SET_ACTIONS(setMethods)
      }
      // this.$router.go()
      await this.$setItem('navEntityHistory', [])
      this.$router.push(`/entity/${entityTitle}`).catch((err) => {})
    },
    async checkHasDrive() {
      const user = await this.$getItem('userInfo')
      this.hasDrive = !!user.drive
    },
    async checkEntities() {
      //checa se é admin com todas funcionalidades na entidade selecionada
      const routedEntity = await this.$getItem('rootEntities')
      // console.log('mostra entidades do usuário->', routedEntity)
      routedEntity.forEach((entity) => {
        //modulesMaxManagements vuex gambiarra
        let actions = 0

        entity.privileges.actions.forEach((action) => {
          let check = this.modulesMaxManagements[action.name]
          if (check == '') {
            actions++
          }
        })

        if (actions == Object.keys(this.modulesMaxManagements).length) {
          this.adminEntity.push(entity)
        } else {
          this.entities.push(entity)
        }
      })
    },
    goToDrive() {
      this.$router.push('/drive')
    },
    goToHome() {
      this.$router.push('/home')
    },
  },
}
</script>
<style>
.v-list-item__title {
  white-space: normal !important;
}
</style>
